## changes from kernel-3.9
 * name of [irq-handler](https://elixir.bootlin.com/linux/v4.19/source/include/linux/irqdesc.h#L197) changed (since 3.9)
 * gpio_chip changed (split into [gpio_chip](https://elixir.bootlin.com/linux/v4.19/source/include/linux/gpio/driver.h#L232) and [gpio_irq_chip](https://elixir.bootlin.com/linux/v4.19/source/include/linux/gpio/driver.h#L27)) (since 4.8)

## Documentation of interfaces
 * [gpio-driver](https://www.kernel.org/doc/Documentation/gpio/driver.txt)
 * [leds-class](https://www.kernel.org/doc/Documentation/leds/leds-class.txt)
 * [watchdog-api](https://www.kernel.org/doc/Documentation/watchdog/watchdog-kernel-api.txt), [watchdog-parameters](https://www.kernel.org/doc/Documentation/watchdog/watchdog-parameters.txt), [watchdog-kernel-api](https://www.kernel.org/doc/Documentation/watchdog/watchdog-kernel-api.txt)

 * [sysfs-leds](https://www.kernel.org/doc/Documentation/ABI/testing/sysfs-class-led)
 * [sysfs-watchdog](https://www.kernel.org/doc/Documentation/ABI/testing/sysfs-class-watchdog)

## Further resources
 * https://elixir.bootlin.com/linux/v4.19/source
 * https://www.kernel.org/doc/html/latest/driver-api/gpio/driver.html
 * https://notes.shichao.io/lkd/ch7/ 
 * https://elinux.org/images/8/8c/Zyngier.pdf
